unit mgEfeito;

interface

uses windows, messages, sysutils, mmsystem,
     dvcrt, dvwin, dvform, dvarq, dvwav,
     mgMsg, mgVars, grAmost;

procedure menuEfeito;

implementation

{--------------------------------------------------------}

procedure adicionaEco;
var
    a, b: TStereo16;
    i, n, dist: integer;
    fator1_eco, fator2_eco: real;

begin
    fator1_eco := fator_eco / 100.0;
    fator2_eco := 1.0 - fator1_eco;

    with som do
        begin
            dist := (velocidade div 11025) * dist_eco;
            n := numAmostras+dist;
            amostra [n-1] := SILENCIO;   // precria area de silencio no fim
            for i := n-1 downto 0 do
                begin
                     a := amostra[i];
                     b := amostra [i-dist];
                     // nota: o objeto som retorna silncio para acessos a ndices < 0
                     a.left  := trunc(a.left  * fator1_eco) + trunc(b.left  * fator2_eco);
                     a.right := trunc(a.right * fator1_eco) + trunc(b.right * fator2_eco);
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGECO', 1);  {'Eco adicionado'}
end;

{--------------------------------------------------------}

procedure adicionaReverber;
var
    a, b: TStereo16;
    i, n, dist: integer;
    fator1_reverb, fator2_reverb: real;

begin
    fator1_reverb := fator_reverb / 100.0;
    fator2_reverb := 1.0 - fator1_reverb;
    with som do
        begin
            dist := (velocidade div 11025) * dist_reverb;
            n := numAmostras+dist;
            amostra [n-1] := SILENCIO;   // precria area de silencio no fim
            for i := 0 to n-1 do
                begin
                     a := amostra[i];
                     b := amostra [i-dist];
                     a.left  := trunc(a.left  * fator1_reverb) + trunc(b.left  * fator2_reverb);
                     a.right := trunc(a.right * fator1_reverb) + trunc(b.right * fator2_reverb);
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGREV', 1);  {'Reverberao adicionada'}
end;

{--------------------------------------------------------}

procedure fadeIn;
var inicio, fim: integer;
begin
    inicio := 0;
    fim := cursor;
    som.rampa (inicio, fim, 0.0, 1.0);
    mensagem ('MGOK', 1);  {'Ok'}
end;

{--------------------------------------------------------}

procedure fadeOut;
var inicio, fim: integer;
begin
    inicio := cursor;
    fim := som.numAmostras-1;
    som.rampa (inicio, fim, 1.0, 0.0);
    mensagem ('MGOK', 1);  {'Ok'}
end;

{--------------------------------------------------------}

procedure sobeVolume;
begin
    som.rampa(0, som.numAmostras-1, 1.25, 1.25);
    mensagem ('MGVOLAUM', 1);  {'Aumentei o volume em 25 por cento'}
end;

{--------------------------------------------------------}

procedure desceVolume;
begin
    som.rampa(0, som.numAmostras-1, 0.75, 0.75);
    mensagem ('MGVOLDIM', 1);  {'Diminu o volume em 25 por cento'}
end;

{--------------------------------------------------------}

procedure retrogrado;
var i: integer;
    a: TStereo16;
begin
    with som do
        begin
            for i := 0 to (numAmostras-1) div 2 do
                begin
                     a := amostra[i];
                     amostra[i] := amostra[numAmostras-1-i];
                     amostra[numAmostras-1-i] := a;
                end;
        end;

    mensagem ('MGSOMINV', 1);  {'Som virado de trs para diante'}
end;

{--------------------------------------------------------}

procedure aplicaSenha;
var i: integer;
    a: TStereo16;
    senha: array [0..255] of byte;
    salva: word;
    x: smallInt;
    s: string;
    erro: integer;
begin
    mensagem ('MGDIGSEN', 0);   {'Digite a senha com 6 digitos: '}
    salva := textAttr;
    textAttr := 0;
    readln (s);
    textAttr := salva;

    if s = '' then
        begin
            mensagem ('MGDESIST', 1);  {'Desistiu'}
            exit;
        end;

    val (s, x, erro);

    senha[0] := 17 xor (x and 255) xor ((x shr 5) and 255);
    for i := 1 to 255 do
        senha [i] := (senha[i-1] * 13 + 89) mod 255;

    with som do
        begin
            for i := 0 to numAmostras-1 do
                begin
                     a := amostra[i];
                     x := smallInt (word (senha[i and $ff]) shl 8);
                     a.left   := a.left  xor x;
                     a.right  := a.right xor x;
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGSENHAP', 1);  {'Senha aplicada'}
end;

{--------------------------------------------------------}

procedure ajudaEfeito;
begin

    sintSom ('MGMENU');

    textBackground (RED);
    mensagem ('MGASOPC',2); {'As opes so:'}
    textBackground (BLACK);
    writeln;

    mensagem ('MGVOLSOB', 1); {'+ - Aumenta Volume'}
    mensagem ('MGVOLDES', 1); {'- - Diminui volume'}
    mensagem ('MGOPECO', 1);  {'E - Eco'}
    mensagem ('MGOPREV', 1);  {'R - Reverbera'}
    mensagem ('MGFADEIN', 1); {'I - Fade In'}
    mensagem ('MGFADEOU', 1); {'O - Fade Out'}
    mensagem ('MGVOLTSO', 1); {'V - Inverte o som'}
    mensagem ('MGCODSEN', 1); {'S - Codifica com senha'}
end;

{--------------------------------------------------------}

    procedure MenuAdiciona (msg: string);
begin
    popupMenuAdiciona (msg, pegaTextoMensagem (msg));
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasEfeitos: char;
var n: integer;

const
    nopc = 8;
    tabLetrasOpcoes: string [nopc] = '+-eriovs';

begin
    sintSom ('MGMENU');

    garanteEspacoTela(nopc);
    popupMenuCria (wherex, wherey, 24, nopc, MAGENTA);
    menuAdiciona ('MGVOLSOB');  {'+ - Aumenta Volume'}
    menuAdiciona ('MGVOLDES');  {'- - Diminui volume'}
    menuAdiciona ('MGOPECO');   {'E - Eco'}
    menuAdiciona ('MGOPREV');   {'R - Reverber'}
    menuAdiciona ('MGFADEIN');  {'I - Fade In'}
    menuAdiciona ('MGFADEOU');  {'O - Fade Out'}
    menuAdiciona ('MGVOLTSO');  {'V - Inverte o som'}
    menuAdiciona ('MGCODSEN');  {'S - Codifica com senha'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= nopc) then
        selSetasEfeitos := tabLetrasOpcoes[n]
    else
        selSetasEfeitos := ESC;

end;

{--------------------------------------------------------}
{               ciclo de processamento geral
{--------------------------------------------------------}

procedure menuEfeito;
var
    processando: boolean;
    c, c2: char;
label executa;
begin
    processando := true;
    while processando do
        begin
            while keypressed do readkey;

            textBackground (BLUE);
            mensagem ('MGOPEF', 0);   {'Qual efeito? '}
            textBackground (BLACK);

            sintLeTecla (c, c2);
            writeln;

            if c = #$0 then
                begin
                    if c2 = F1 then
                        ajudaEfeito
                    else
                    if (c2 = CIMA) or (c2 = BAIX) then
                        begin
                            c := selSetasEfeitos;
                            goto executa;
                        end
                end
            else
               begin
        executa:
                    case upcase(c) of
                        '+': sobeVolume;
                        '-': desceVolume;
                        'E': adicionaEco;
                        'R': adicionaReverber;
                        'I': fadeIn;
                        'O': fadeOut;
                        'V': retrogrado;
                        'S': aplicaSenha;
                        ESC: processando := false;
                    else
                        mensagem ('MGOPINV', 2); {'Opo invlida, F1 ajuda'}
                    end;
                end;
        end;
    writeln;
end;

end.
