{--------------------------------------------------------}
{
{    Mini gravador de som
{
{    Por Jos Antonio Borges
{
{    Verso 1.0 Em 29/05/98
{    Verso 2.0 em maio/2006
{
{--------------------------------------------------------}

program minigrav;

uses
  dvcrt,
  dvwin,
  dvform,
  dvarq,
  dvwav,
  mgEfeito,
  mgMsg,
  mgVars,
  grAmost,
  mgmp3,
  windows,
  messages,
  sysutils,
  mmsystem,
  mgdivide,
  mgconfig;

{---------------------------------------------------------------------}

procedure inicializa;
var dir: string;
begin
    clrscr;
    setWindowText (crtWindow, 'GRAVADOR DE SOM');
    delay (200);

    getDir (0, dirTrab);
    if dirTrab [length (dirTrab)] <> '\' then dirTrab := dirTrab + '\';

    dir := sintAmbiente ('MINIGRAV', 'DIRMINIGRAV');
    if dir = '' then
        dir := 'c:\winvox\som\minigrav';
    sintInic (0, dir);

    mensagem ('MGINIC', 0);  {'Gravador de som'}
    write (' - v.');
    sintWrite (versao);
    writeln;
    writeln;
    while sintFalando do waitMessage;

    nomeArq := '';
    som:= TAmostras.Create;
    cursor := 0;
    marca := 0;

    configPadrao;
    pegaParamConfig;
    som.maxMemoria := maxMemoria * 1024 * 1024;
end;

{--------------------------------------------------------}

procedure carregaSom;
begin
    mensagem ('MGCRGSOM', 1);   {'Carregando som'}

    cursor := 0;
    marca := 0;
    som.maxMemoria := maxMemoria * 1024 * 1024;
    if nomeArq <> '' then
        if not som.leArquivo(nomeArq) then
            begin
                if som.faltaDeMemoria then
                    mensagem ('MGFALMEM', 1)   {'No h memria suficiente para esta edio'}
                else
                    mensagem ('MGARQERR', 1);  {'Arquivo incompatvel com este programa'}
                nomeArq := '';
                exit;
            end;
end;

{--------------------------------------------------------}

procedure obtemNomeArquivo (inicial: boolean);
var pnome: array [0..255] of char;
label repete;
begin

    if inicial and (paramCount <> 0) then
        begin
            nomeArq := cmdLine;
            if nomeArq [1] = '"' then
                begin
                    delete (nomeArq, 1, 1);
                    while (nomeArq <> '') and (nomeArq[1] <> '"') do
                         delete (nomeArq, 1, 1);
                    delete (nomeArq, 1, 1);
                end;
             while (nomeArq <> '') and (nomeArq[1] = ' ') do  delete (nomeArq, 1, 1);
        end
    else
        begin
repete:
            garanteEspacoTela(10);
            mensagem ('MGNOMARQ', 1);            {'Informe o nome do arquivo: '}
            nomeArq := obtemNomeArqMasc(10, '*.WAV');
        end;

    if nomeArq = '' then
        if (teclaObtemNomeArq <> ENTER) and (teclaObtemNomeArq <> ESC) then goto repete
                                                                       else exit;

    if nomeArq [length (nomeArq)] = '\' then goto repete;

    if maiuscAnsi (copy (nomeArq, length (nomeArq)-3, 4)) = '.MP3' then
        begin
            if fileExists (nomeArq) then
                begin
                    mensagem ('MGNAOMP3', 1);  {'No edito diretamente MP3'}
                    mensagem ('MGMP3WAV', 1 ); {'Vou converter de MP3 para WAV, aguarde'}

                    if not decodificaMP3 (nomeArq, nomeArq+'.wav') then
                        begin
                            mensagem ('MGERRCNV', 2);  {'Converso mal sucedida'}
                            goto repete;
                        end;
                end;
        end;

    writeln (nomeArq);
    strPCopy (pnome, 'MINIGRAV ' + nomeArq);
    setWindowText (crtWindow, pnome);

    if maiuscAnsi (copy (nomeArq, length (nomeArq)-3, 4)) <> '.WAV' then
         nomeArq := nomeArq + '.wav';   // pode at ficar "nome.MP3.WAV"
end;

{--------------------------------------------------------}

function gravaSomInicial: boolean;
var
    c, c2: char;
    qualidade: char;
    nomeJanela: string;

begin
    gravaSomInicial := false;

    mensagem ('MGRADTLF', 0);  {'Qualidade CD, rdio ou telefone ? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then
        begin
             nomeArq := '';
             exit;
        end;

    qualidade := upcase (c);

    som.zera;
    case qualidade of
        'C':  begin
                  som.velocidade := 44100;
                  som.bitsPorAmostra := 16;
              end;

        'T':  begin
                  som.velocidade := 11025;
                  som.bitsPorAmostra := 8;
              end;
        else
              begin
                  som.velocidade := 22050;
                  som.bitsPorAmostra := 16;
              end;
    end;

    mensagem ('MGSTMONO', 0);  {'Estreo ou Mono? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then
        begin
             nomeArq := '';
             exit;
        end;

    if upcase (c) in ['E', 'S'] then
        som.canais := 2
    else
        som.canais := 1;

    mensagem ('MGINIGRV', 1);   {'Tecle Enter para iniciar, ESC termina'}
    repeat
        c := readkey;
    until (c = ESC) or (c = ENTER);
    if c = ESC then
        begin
            nomeArq := '';
            exit;
        end;

    nomeJanela := 'MINIGRAV Gravando... ' + nomeArq;
    if length (nomeJanela) > 133 then
        nomeJanela := copy (nomeJanela, 1, 133) + '...';
    setWindowTitle (nomeJanela);
    som.zera;
    som.nBufGravacao := nbufGrava;
    if som.grava (nomeArq) then
        begin
            gravaSomInicial := true;
            mensagem ('MGOK', 1);   {'Ok'}
        end
    else
        begin
            gravaSomInicial := false;
            if som.faltaDeMemoria then
                mensagem ('MGFALMEM', 1)    {'No h memria suficiente para esta edio'}
            else
                mensagem ('MGERRGRV', 1);   {'Erro de gravao'}
        end;
    nomeJanela := 'MINIGRAV ' + nomeArq;
    if length (nomeJanela) > 133 then
        nomeJanela := copy (nomeJanela, 1, 133) + '...';
    setWindowTitle (nomeJanela);
end;

{--------------------------------------------------------}

function cursorParaTempo (cursor: integer): string;
begin
    cursorParaTempo := intToStr (cursor div som.velocidade)+
         ':'+ intToStr (cursor mod som.velocidade div (som.velocidade div 10));
end;

{--------------------------------------------------------}

procedure informaPosicao;
begin
    mensagem ('MGTEMPOT', 0);  {'Tempo total: '};
    sintWrite (cursorParaTempo (som.numAmostras));
    write ('  ');
    mensagem ('MGPOSCUR', 0);  {'posio do cursor: '}
    sintWrite (cursorParaTempo (cursor));
    write ('  ');
    mensagem ('MGPERCEN', 0);  {'percentual: '}
    sintWrite (intToStr(100 * cursor div som.numAmostras));
    writeln;
end;

{--------------------------------------------------------}

procedure tocaSom;
var c, c2: char;
    passo: integer;
    erro: integer;
    salva: integer;
    s: string;
label ativa;

    procedure mostraPosicao;
    begin
        gotoxy (1, wherey);
        write (cursorParaTempo (cursor) + '       ');
    end;

begin
    mensagem ('MGESPTOC', 1);  {'Use espao para tocar, F1 ajuda'}

    while sintFalando do waitMessage;
    keyStopsWave := false;   // para teclado no interromper

    salva := maxBufWaves;
    maxBufWaves := nbufToca;
    passo := som.velocidade div 10;

    repeat
        c2 := #0;
        c := readkey;
        if c = #$0 then c2 := readkey;
        while keypressed do readkey;

ativa:
        if c = ' ' then
            begin
                if cursor >= som.numAmostras then
                    mensagem ('MGFIMSOM', 1)    {'Fim do som'}
                else
                    begin
                        if cursor < 0 then cursor := 0;
                        while (cursor <= som.numAmostras) and (not keypressed) do
                              begin
                                  som.toca (cursor, passo);
                                  cursor := cursor + passo;
                                  mostraPosicao;
                              end;

                        writeln;
                        if keypressed then
                            begin
                                c2 := #0;
                                c := readkey;
                                if c = #$0 then c2 := readkey;
                                if c <> ' ' then goto ativa;
                            end;
                    end;
            end
        else
        if upcase (c) = 'M' then
            begin
                marca := cursor;
                mensagem ('MGMEMOR', 1);   {'Posio do cursor memorizada'}
            end
        else
        if upcase (c) = 'V' then
            begin
                cursor := marca;
                mensagem ('MGOK', 1);      {'Ok'}
            end
        else
        if c = #$0 then
            begin
                if c2 = F1 then
                    begin
                        sintSom ('MGMENU');
                        textBackground (RED);
                        mensagem ('MGASOPC',1); {'As opes so:'}
                        textBackground (BLACK);
                        mensagem ('MGAJTOC1', 1);  {'Espao toca e para, esc termina'}
                        mensagem ('MGAJTOC2', 1);  {'Posicione com direita, esquerda, home e end.'}
                        mensagem ('MGAJTOC3', 1);  {'Page Up e Page Down saltam 10 segundos'}
                        mensagem ('MGAJTOC4', 1);  {'M memoriza o ponto do cursor'}
                        mensagem ('MGAJTOC5', 1);  {'V volta ao ponto memorizado'}
                    end
                else
                if c2 = HOME then
                    begin
                         cursor := 0;
                         mostraPosicao;
                         mensagem ('MGINISOM', 1);    {'Incio do som'}
                    end
                else
                if c2 = TEND then
                    begin
                         cursor := som.numAmostras;
                         mostraPosicao;
                         mensagem ('MGFIMSOM', 1);    {'Fim do som'}
                    end
                else
                if c2 = DIR then
                    begin
                        if cursor <= som.numAmostras then
                                som.toca (cursor, passo);
                        if GetKeyState(VK_SHIFT) < 0 then
                            cursor := cursor + passo div 10
                        else
                            cursor := cursor + passo;
                        if cursor >= som.numAmostras then
                            begin
                                sintBip;
                                cursor := som.numAmostras;
                            end;
                        mostraPosicao;
                    end
                else
                if c2 = ESQ then
                    begin
                        if GetKeyState(VK_SHIFT) < 0 then
                            cursor := cursor - passo div 10
                        else
                            cursor := cursor - passo;
                        if cursor >= 0 then
                            som.toca (cursor, passo);
                        if cursor <= 0 then
                            begin
                                sintBip;
                                cursor := 0;
                            end;
                        mostraPosicao;
                    end
                else
                if c2 = PGDN then
                    begin
                        if cursor < som.numAmostras then
                            begin
                                sintClek;
                                cursor := cursor + passo * 10;
                            end;
                        if cursor >= som.numAmostras then
                            begin
                                sintBip;
                                cursor := som.numAmostras;
                            end;
                        mostraPosicao;
                    end
                else
                if c2 = PGUP then
                    begin
                        if cursor > 0 then
                        begin
                            sintClek;
                            cursor := cursor - passo * 10;
                        end;
                        if cursor < 0 then
                            begin
                                sintBip;
                                cursor := 0;
                            end;
                        mostraPosicao;
                    end
                else
                if c2 = CTLDIR then
                    som.toca (cursor, som.numAmostras - cursor)
                else
                if c2 = CTLESQ then
                    som.toca (0, cursor)
                else
                if c2 = F6 then
                    informaPosicao
                else
                if c2 = F5 then
                    begin
                        writeln;
                        sintWrite ('Informe a posio em segundos: ');
                        sintReadln (s);
                        s := trim (s);
                        if s <> '' then
                            begin
                                val (s, cursor, erro);
                                if (erro <> 0) or (cursor < 0) then
                                    begin
                                        mensagem ('MGERPOSI', 1);  {'Erro de posicionamento'}
                                        cursor := 0;
                                    end
                                else
                                    begin
                                        cursor := cursor * som.velocidade;
                                        if cursor >= som.numAmostras then
                                            begin
                                                sintBip;
                                                cursor := som.numAmostras;
                                            end;
                                    end;
                            end;
                    end;
            end;

    until (c = #$1b) or (c = ENTER);

    keyStopsWave := true;
    maxBufWaves:= salva;
    writeln;
end;

{--------------------------------------------------------}

procedure salvaArquivoRapido;
var nomeNovo: string;
    pnome: array [0..255] of char;
begin
    nomeNovo := nomeArq;
    if nomeNovo = '' then
        begin
            mensagem ('MGNOMARQ', 1);            {'Informe o nome do arquivo: '}
            sintReadln (nomeNovo);
            if nomeNovo = '' then
                begin
                    mensagem ('MGDESIST', 1);    {'Desistiu'}
                    exit;
                end;
        end;

    if not som.gravaArquivo(nomeNovo) then
        mensagem ('MGERRGRV', 1)   {'Erro de gravao'}
    else
        begin
            mensagem ('MGARQSLV', 1);      {'OK, arquivo salvo'}
            nomeArq := nomeNovo;
            strPCopy (pnome, 'MINIGRAV ' + nomeArq);
            setWindowText (crtWindow, pnome);
        end;
end;

{--------------------------------------------------------}

procedure veSeSalvaMP3 (nomeNovo: string);
var arq: file;
begin
    if (length(nomeNovo) > 8) and
       (maiuscAnsi(copy (nomeNovo, length(nomeNovo)-7, 8)) = '.MP3.WAV') then
           begin
               mensagem ('MGWAVMP3', 1);  {'Vou converter de wav para mp3, aguarde'}
               if not codificaMp3 (nomeNovo, copy (nomeNovo, 1, length(nomeNovo)-4)) then
                   mensagem ('MGERRCNV', 2)  {'Converso MP3 foi mal sucedida'}
               else
                   begin
                       assign (arq, nomeNovo);
                       {$I-} erase (arq); {$I+}
                       if ioresult <> 0 then;
                   end;
           end;
end;

{--------------------------------------------------------}

procedure salvaArquivo (nomeArq: string);
var t, c, c2: char;
    nomeNovo: string;
    som2: TAmostras;
    pnome: array [0..255] of char;

label desistiu, salvamentoMP3;
begin
    som2 := NIL;
    nomeNovo := nomeArq;

    mensagem ('MGMANTOR', 0);            {'Mantenho parmetros originais da gravao? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then goto desistiu;

    if upcase (c) = 'S' then
        begin
            salvaArquivoRapido;
            goto salvamentoMP3;
        end;

    mensagem ('MGNOMNAR', 1);            {'Informe o novo nome do arquivo: '}
    garanteEspacoTela(2);
    c := sintEdita (nomeNovo, wherex, wherey, 255, true);
    writeln;
    if (c = ESC) or (nomeNovo = '') then goto desistiu;

    if (maiuscAnsi (copy (nomeNovo, length (nomeNovo)-3, 4)) = '.MP3') or
                                   (pos ('.', nomeNovo) = 0) then
         nomeNovo:= nomeNovo + '.wav';

    mensagem ('MGRADTLF', 0);  {'Qualidade CD, rdio ou telefone ? '}
    sintLeTecla (t, c2);
    writeln;
    if t = ESC then exit;

    mensagem ('MGSTMONO', 0);  {'Estreo ou Mono? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then goto desistiu;

    som2:= TAmostras.Create;
    case upcase(t) of
        'C':  begin
                  som2.reAmostra (som, 44100);
                  som2.bitsPorAmostra := 16;
              end;
        'T':  begin
                  som2.reAmostra (som, 11025);
                  som2.bitsPorAmostra := 8;
              end;
        else
              begin
                  som2.reAmostra (som, 22050);
                  som2.bitsPorAmostra := 16;
              end;
    end;

    if upcase (c) in ['E', 'S'] then
        som2.canais := 2
    else
        som2.canais := 1;

    som.Free;
    som := som2;
    som2 := NIL;

    if not som.gravaArquivo(nomeNovo) then
        begin
            mensagem ('MGERRGRV', 1);      {'Erro de gravao'}
            exit;
        end
    else
        nomeArq := nomeNovo;

    mensagem ('MGARQSLV', 2);       {'OK, arquivo salvo'}
    strPCopy (pnome, 'MINIGRAV ' + nomeArq);
    setWindowText (crtWindow, pnome);

salvamentoMP3:
    veSeSalvaMP3 (nomeNovo);
    exit;

desistiu:
    if som2 <> NIL then som2.free;
    mensagem ('MGDESIST', 1);        {'Desistiu'}
end;

{--------------------------------------------------------}

procedure removeAntes;
begin
    som.removeTrecho(0, cursor);
    marca := marca - cursor;
    if marca < 0 then marca := 0;
    cursor := 0;
    mensagem ('MGREMANT', 1);  {'Trecho anterior removido'}
end;

{--------------------------------------------------------}

procedure removeDepois;
begin
    som.removeTrecho(cursor, som.numAmostras - cursor);
    if marca > cursor then marca := cursor;
    mensagem ('MGREMPOS', 1);  {'Trecho posterior removido'}
end;

{--------------------------------------------------------}

procedure removeMeio;
var aRemover: integer;
begin
    aRemover := abs (cursor - marca);
    if marca < cursor then
        cursor := marca
    else
        marca := cursor;
    som.removeTrecho(cursor, aRemover);
    mensagem ('MGTRCREM', 1);  {'Trecho removido'}
end;

{--------------------------------------------------------}

procedure removeTudo;
begin
    som.removeTrecho(0, som.numAmostras);
    marca := 0;
    mensagem ('MGDESTRU', 1);  {'Ok, toda gravao foi removida.'}
end;

{--------------------------------------------------------}

procedure trataRemocao;
var opcao: char;
begin
    mensagem ('MGTRAREM', 0); {'A - remove antes do cursor, D - depois, T - tudo'}
                              {'M - remove entre cursor e ponto memorizado: '}
    opcao:= sintReadKey;
    writeln;

    case upcase(opcao) of
        'A': removeAntes;
        'D': removeDepois;
        'T': removeTudo;
        'M': removeMeio;
    else
        mensagem ('MGOPINV', 1); {'Opo invlida'}
    end;
end;

{--------------------------------------------------------}

procedure undo;
var c, c2: char;
begin
    mensagem ('MGCNFUND', 0);   {'Vou recuperar a ltima verso salva, confirma? '}
    sintLeTecla (c, c2);
    writeln;
    if upcase (c) <> 'S' then exit;

    som.leArquivo(nomeArq);
    mensagem ('MGUNDO', 1);  {'Voltei ao ltimo arquivo gravado'}
end;

{--------------------------------------------------------}

procedure novaGravacao;
var c, c2: char;
begin
    mensagem ('MGQUERSV', 0);   {'Quer salvar arquivo atual? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then
        begin
            mensagem ('MGDESIST', 2);  {'Desistiu'}
            exit;
        end;

    if upcase(c) <> 'N' then
        begin
            salvaArquivoRapido;
            veSeSalvaMP3 (nomeArq);
        end;

    som.zera;
    mensagem ('MGNOVSOM', 1);  {'Novo som criado'}
    obtemNomeArquivo (false);
    if not FileExists(nomeArq) then
        gravaSomInicial;
    carregaSom;
end;

{--------------------------------------------------------}

procedure gravaMais;
var c, c2: char;
    som2: TAmostras;
    arqTemp: file;
    nomeTemp, nomeJanela: string;
    pnome, tempPath: array[0..255] of char;
    passo: integer;


begin
    getTempPath (256, tempPath);
    getTempFilename (tempPath, 'WAV', 0, pnome);
    nomeTemp := strPas (pnome);

    som2 := TAmostras.CriaSilencio (som.canais, som.velocidade, som.bitsPorAmostra, 0);
    som2.nBufGravacao := nbufGrava;
    cursor := som.numAmostras;
    passo := som.velocidade*10;

    repeat
        nomeJanela := 'MINIGRAV ' + nomeArq;
        if length (nomeJanela) > 133 then
            nomeJanela := copy (nomeJanela, 1, 133) + '...';
        setWindowTitle (nomeJanela);
        mensagem ('MGCONTGR', 1);  {'Aperte enter para continuar gravao, ESC termina'}
        c := readkey;
        if sintFalando then sintPara;

        if c = ENTER then
            begin
                nomeJanela := 'MINIGRAV Gravando... ' + nomeArq;
                if length (nomeJanela) > 133 then
                nomeJanela := copy (nomeJanela, 1, 133) + '...';
                setWindowTitle (nomeJanela);
                som2.grava(nomeTemp);
                som.adiciona(som2);
                som2.zera;
                sintBip;
            end
        else
        if c = #$0 then
            if readkey = PGUP then
                begin
                    sintClek;
                    cursor := cursor - passo;
                    if cursor < 0 then cursor := 0;
                    som.toca (cursor, som.numAmostras-cursor);
                    sintBip;
                end;

        cursor := som.numAmostras;
    until c = #$1b;
    writeln;
    som2.free;

    assign (arqTemp, nomeTemp);
    {$I-} erase (arqTemp); {$I-}
    if ioresult <> 0 then ;  // ignora erro

    nomeJanela := 'MINIGRAV ' + nomeArq;
    if length (nomeJanela) > 133 then
        nomeJanela := copy (nomeJanela, 1, 133) + '...';
    setWindowTitle (nomeJanela);
    mensagem ('MGSALVAG', 1);   {'J posso armazenar em disco? }
    sintLeTecla (c, c2);
    writeln;
    if (upcase(c) <> 'N') and (c <> ESC) then
        salvaArquivoRapido;
end;

{--------------------------------------------------------}

procedure misturaOutroSom;
var
    nomeMist: string;
    som3, som4: TAmostras;
    fatorOrig, fatorMist: real;
    c, c2: char;
    inicioMist: integer;
    tipoMist: char;
    erro: boolean;
    nomeTemp: string;
    pnome, tempPath: array[0..255] of char;
    arqTemp: file;
    ns: string;
    erroDig: integer;

label fim;
begin
    mensagem ('MGNOMMIS', 1);   {'Qual o arquivo de som a misturar ?'}
    nomeMist := obtemNomeArqMasc(10, '*.WAV');
    if nomeMist = '' then exit;
    if pos ('.', nomeMist) = 0 then
        nomeMist := nomeMist + '.wav';
    writeln (nomeMist);

    if not FileExists(NomeMist) then
        begin
            mensagem ('MGERRNOM', 1);   {'Erro no nome do arquivo'}
            exit;
        end;

    nomeTemp := '';
    if maiuscAnsi (copy (nomeMist, length (nomeMist)-3, 4)) = '.MP3' then
        begin
            getTempPath (256, tempPath);
            getTempFilename (tempPath, 'WAV', 0, pnome);
            nomeTemp := strPas (pnome);

            if not decodificaMp3 (nomeMist, nomeTemp) then
                begin
                    mensagem ('MGERRCNV', 2);   {'Converso MP3 foi mal sucedida'}
                    exit;
                end;

            nomeMist := nomeTemp;
        end;

    som3 := TAmostras.Create;
    som3.leArquivo(nomeMist);

    if nomeTemp <> '' then
        begin
            assign (arqTemp, nomeTemp);
            {$I-} erase (arqTemp);  {$I+}
            if ioresult <> 0then;
        end;

    som3.canais := som.canais;
    som3.bitsPorAmostra := som.bitsPorAmostra;

    if som3.velocidade <> som.velocidade then   // compatibiliza velocidades
        begin
            som4 := TAmostras.Create;
            som4.Clone(som3);
            som4.reamostra (som3, som.velocidade);
            som3.free;
            som3 := som4;
        end;

    fatorOrig := 1.0;
    fatorMist := 1.0;
    inicioMist := 0;

    repeat
        erro := false;

        mensagem ('MGADIFUN', 0);    {'Adio, Mistura ou Fundo sonoro? '}
        sintLeTecla (c, c2);
        writeln;
        tipoMist := upcase(c);

        case tipoMist of
            'A', 'M':  ;
            'F':
                    begin
                         mensagem ('MGFATORI', 0);   {'Percentual do som original, sugiro 70'}
                         sintReadln (ns);
                         val (trim(ns), fatorOrig, erroDig);
                         if (erroDig = 0) and (fatorOrig < 100) then
                             fatorOrig := fatorOrig / 10
                         else
                             fatorOrig := 0.7;

                         mensagem ('MGFATMIS', 0);   {'Percentual do som a misturar, sugiro 30'}
                         sintReadln (ns);
                         val (trim(ns), fatorMist, erroDig);
                         if (erroDig = 0) and (fatorMist < 100) then
                             fatorMist := fatorMist / 10
                         else
                             fatorMist := 0.3;
                    end;
            ESC:
                    begin
                        mensagem ('MGDESIST', 1);  {'Desistiu...'}
                        goto fim;
                    end;
        else
            erro := true;
        end;
    until not erro;

    repeat
        erro := false;

        mensagem ('MGONDMST', 0);   {'Mistura no Incio, no Cursor ou no Fim do som? '}
        sintLeTecla (c, c2);
        writeln;

        case upcase(c) of
            'I':  inicioMist := 0;
            'F':  inicioMist := som.numAmostras-1;
            'C':  inicioMist := cursor;
            ESC:  begin
                      mensagem ('MGDESIST', 1);  {'Desistiu...'}
                      goto fim;
                  end;
        else
            erro := true;
        end;
    until not erro;

    if tipoMist = 'A' then
        som.abreTrecho(inicioMist, som3.numAmostras);

    som.mistura(som3, inicioMist, fatorOrig, fatorMist);
    mensagem ('MGMISTUR', 1);   {'Sons misturados'}

fim:
    som3.free;
end;

{--------------------------------------------------------}

function finaliza: boolean;
var opcao: char;
    c, c2: char;
begin
    finaliza := false;
    mensagem ('MGCONFIM', 0); {'Confirma o fim do programa ? '}
    opcao:= sintReadKey;
    writeln;

    if upcase(opcao) <> 'S' then
        exit;

    mensagem ('MGQUERSV', 0);   {'Quer salvar arquivo atual? '}
    sintLeTecla (c, c2);
    writeln;
    if c = ESC then exit;

    if upcase(c) <> 'N' then 
        begin
            salvaArquivoRapido;
            veSeSalvaMP3 (nomeArq);
        end;

    som.free;

    finaliza := true;
end;

{--------------------------------------------------------}

procedure infoSom;
var s: string;
begin
    mensagem ('MGARQTRB', 0);           {'Arquivo de trabalho: '}
    s := nomeArq;
    if maiuscAnsi (copy (s, length(s)-7, 8)) = '.MP3.WAV' then
        delete (s, length(s)-3, 4);
    sintWriteln (s);

    mensagem ('MGIVEL', 0);             {'Velocidade: '}
    sintWriteint (som.velocidade);
    writeln;

    mensagem ('MGIQUALI', 0);           {'Qualidade: '}

    if som.bitsPorAmostra = 8 then
        mensagem ('MGI8BIT',  1)        {'8 Bits '}
    else
        mensagem ('MGI16BIT', 1);       {'16 Bits '}

    if som.canais = 1 then
        mensagem ('MGIMONO', 1)         {'Mono'}
    else
        mensagem ('MGISTERE', 1);       {'Stereo'}

    while sintFalando do waitMessage;
    writeln;
end;

{--------------------------------------------------------}

procedure ajudaPrincipal;
begin

    sintSom ('MGMENU');

    textBackground (RED);
    mensagem ('MGASOPC',1); {'As opes so:'}
    textBackground (BLACK);
    writeln;

    mensagem ('MGTOCA', 1);   {'T - Toca'}
    mensagem ('MGGRAVA', 1);  {'G - Grava mais'}
    mensagem ('MGNOVO', 1);   {'N - Novo som'}
    mensagem ('MGREMOVE', 1); {'R - Remove'}
    mensagem ('MGMIXA', 1);   {'M - Mistura'}
    mensagem ('MGEFEIT', 1);  {'E - Efeito'}
    mensagem ('MGDESFAZ', 1); {'D - Desfaz'}
    mensagem ('MGSALVA', 1);  {'S - Salva'}
    mensagem ('MGCONFIG', 1); {'C - Configura'}
    mensagem ('MGINFO', 1);   {'I - Informaes'}
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

procedure MenuAdiciona (msg: string);
begin
    popupMenuAdiciona (msg, pegaTextoMensagem (msg));
end;

{--------------------------------------------------------}

function selSetasPrincipal: char;
var n: integer;

const tabLetrasOpcoes: string = 'tgnrmedsxci';
var nopc: integer;

begin
    sintSom ('MGMENU');

    nopc := length (tabLetrasOpcoes);
    garanteEspacoTela(nopc);
    popupMenuCria (wherex, wherey, 18, nopc, MAGENTA);
    menuAdiciona ('MGTOCA');    {'T - Toca'}
    menuAdiciona ('MGGRAVA');   {'G - Grava mais'}
    menuAdiciona ('MGNOVO');    {'N - Novo som'}
    menuAdiciona ('MGREMOVE');  {'R - Remove'}
    menuAdiciona ('MGMIXA');    {'M - Mistura'}
    menuAdiciona ('MGEFEIT');   {'E - Efeito'}
    menuAdiciona ('MGDESFAZ');  {'D - Desfaz'}
    menuAdiciona ('MGSALVA');   {'S - Salva'}
    menuAdiciona ('MGEXTRAI');  {'X - Extrai'}
    menuAdiciona ('MGCONFIG');  {'C - Configura'}
    menuAdiciona ('MGINFO');    {'I - Informaes'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= nopc) then
        selSetasPrincipal := tabLetrasOpcoes[n]
    else
        selSetasPrincipal := ESC;
end;

{--------------------------------------------------------}
{               ciclo de processamento geral
{--------------------------------------------------------}

procedure menuPrincipal;
var
    processando: boolean;
    c, c2: char;
label executa;
begin
    processando := true;
    while processando do
        begin
            while keypressed do readkey;

            textBackground (BLUE);
            mensagem ('MGOPMG', 0);   {'Gravador, qual sua opcao? '}
            textBackground (BLACK);

            sintLeTecla (c, c2);
            writeln;

            if c = #$0 then
                begin
                    if c2 = DEL then
                        clrscr
                    else
                    if c2 = F1 then
                        ajudaPrincipal
                    else
                    if c2 = F2 then
                        salvaArquivoRapido
                    else
                    if c2 = F3 then
                    begin
                        mensagem ('MGQUERSV', 0);   {'Quer salvar arquivo atual? '}
                        sintLeTecla (c, c2);
                        writeln;
                        if upcase(c) <> 'N' then
                            salvaArquivoRapido;
                        nomeArq := '';
                        carregaSom;
                        mensagem ('MGOK', 1);
                    end
                    else
                    if (c2 = CIMA) or (c2 = BAIX) then
                        begin
                            c := selSetasPrincipal;
                            goto executa;
                        end
                end
            else
               begin
        executa:
                    case upcase(c) of
                        'T': tocaSom;
                        'G': gravaMais;
                   'A', 'R': trataRemocao;
                        'M': misturaOutroSom;
                        'E': menuEfeito;
                        'D': undo;
                        'S': salvaArquivo (nomeArq);
                        'X': extraiArquivo;
                        'C': configura;
                        'N': novaGravacao;
                        'I': infoSom;
                        ESC: if finaliza then
                                 processando := false;
                    else
                    if c <> ESC then
                        mensagem ('MGOPINV', 2); {'Opo invlida, F1 ajuda'}
                    end;
                end;
        end;
end;

{--------------------------------------------------------}

procedure termina;
begin
    mensagem ('MGFIM', 1);      {'Fim do programa'}
    sintFim;
    doneWinCrt;
end;

{--------------------------------------------------------}

begin
    inicializa;

    obtemNomeArquivo (true);
    if nomeArq <> '' then
        begin
            if not FileExists(nomeArq) then
                 gravaSomInicial;

            carregaSom;
        end;

    writeln;
    menuPrincipal;

    termina;
end.
